/*
  Copyright (c) 2017 nosuke

  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.

  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.

  3. This notice may not be removed or altered from any source distribution.

  nosuke
  sasugaanija@gmail.com
*/


#include <stdio.h>
#include "zlib.h"

#define READBUF_SIZE (512 * 1024)

void
usage(char *cmd)
{
    printf("%s [file]\n", cmd);
}


int
main(int argc, char *argv[])
{
    FILE *fp;
    unsigned char buf[READBUF_SIZE];
    size_t sz;
  
    unsigned long crc = crc32(0L, Z_NULL, 0);

    if (argc > 2) {
        usage(argv[0]);
        return -1;
    }
    
    if (argc == 1) {
      fp = stdin;
    } else {
      fp = fopen(argv[1], "r");      
    }
  

    if (fp == NULL) {
        perror("input file open failed");
        return -1;
    }

    while ((sz = fread(buf, 1, READBUF_SIZE, fp)) > 0) {
        crc = crc32(crc, buf, sz);
    }

    fclose(fp);

    printf("%lu\n", (unsigned long)crc);

    return 0;
}
